<template>
  <div>
    <!-- Si l'utilisateur a des projets -->
    <div v-if="userProjects.length > 0">
      <div v-for="project in userProjects" class="flex items-center mt-10 max-w-xl">
        <!-- Photo du projet // WORK IN PROGRESS -->
        <div class="w-20 h-20 rounded-full border-2 border-gray-300">
          <!-- To do : créer l'image -->
          <div class="flex justify-center items-center w-20 h-20 text-center"></div>
        </div>
        <div class="ml-6">
          <!-- Si projet public -->
          <p v-if="project.projectVisibility" class="text-lg">{{ project.projectName }}
            <v-icon name="globe" class="ml-4"/> <v-icon name="pen" class="ml-2 cursor-pointer transition-all hover:text-yellow-600"/>
          </p>
          <!-- Si projet privé -->
          <p v-else class="text-lg max-w-sm">{{ project.projectName }}
            <v-icon name="lock" class="ml-4"/> <v-icon name="pen" class="ml-2 cursor-pointer transition-all hover:text-yellow-600"/>
          </p>
          <!-- Description du projet -->
          <p class="mt-2 text-sm max-h-10 min-h-10 overflow-y-hidden">{{ project.projectDescription }}</p>
          <!-- Date de création du projet -->
          <div class="flex items-center mt-2">
            <p class="text-sm">{{ project.createdAt.toDate() | dateTimeFilter }}</p>
            <!-- Pastille de couleur selon statut du projet -->
            <div v-if="project.projectStatut === 'progress'" class="w-3 h-3 ml-2 rounded-full bg-green-600"></div>
            <div v-else-if="project.projectStatut === 'pause'" class="w-3 h-3 ml-2 rounded-full bg-yellow-600"></div>
            <div v-else-if="project.projectStatut === 'finish'" class="w-3 h-3 ml-2 rounded-full bg-red-600"></div>
          </div>
        </div>
      </div>
    </div>
    <!-- Si l'utilisateur n'a pas de projets -->
    <div v-else>
      <p class="flex items-center mt-10 text-lg">Créer votre premier projet <v-icon name="file" scale="1.4" class="ml-4"/></p>
    </div>
  </div>
</template>

<script>
import { db } from '@/main'
export default {
  name: 'MyProjects',
  props: {
    currentUser: {},
  },
  data: () => ({
    userProjects: []
  }),
  created() {
    // Récupère les projets de l'utilisateur et les stock dans variable userProjects
    db.collection('projects').get().then((snapshot) => {
      snapshot.docs.forEach(doc => {
        if (this.currentUser.id === doc.data().uid) {
          this.userProjects.push(doc.data())
        }
      })
    })
  },
  methods: {
    test() {
      console.log(this.userProjects.length)
    }
  },
  filters: {
    dateTimeFilter: (value) => {
      if (!value) return ''
      return (value.getDate().toString().length === 2 ? value.getDate().toString() : "0" + value.getDate().toString()) + '-' + ((value.getMonth() + 1).toString().length === 2 ? (value.getMonth() + 1).toString() : "0" + (value.getMonth() + 1).toString()) + '-' + value.getFullYear().toString()
    }
  }
}
</script>
